#ifndef _MAIN_H_
#define _MAIN_H_


#ifdef DEBUG
#  define GETOPT_DARGS   "Cd"
#else
#  define GETOPT_DARGS   ""
#endif

#ifdef USE_SVGALIB
#  define GETOPT_SARGS   "w"
#else
#  define GETOPT_SARGS   ""
#endif

#ifdef USE_X11
#  define GETOPT_XARGS   "n"
#else
#  define GETOPT_XARGS   ""
#endif

#define GETOPT_ARGS   "chl:sVv"GETOPT_DARGS""GETOPT_SARGS""GETOPT_XARGS

/***
 * Ova vrijednost mora biti visekratnik velicine Rockforda (znaci 32).
 */
#define SCROLL_BASIC_STEP   4


/***
 * Offseti boja za commodore i spectrum.
 */
#define PALETTE_COMMODORE_OFFSET   224
#define PALETTE_SPECTRUM_OFFSET    240


enum OPTIONS
{
   OPT_DEBUG          = 0x0001,
   OPT_HELP           = 0x0002,
   OPT_VERBOSE        = 0x0004,
   OPT_COMMODORE      = 0x0008,
   OPT_SPECTRUM       = 0x0010,
   OPT_NOMITSHM       = 0x0020,
   OPT_WAITRETRACE    = 0x0040,
   OPT_CHECK_CAVEDATA = 0x0080,
   OPT_GAMELIBDIR     = 0x0100
};

enum GAME_status
{
   GAME_OBJECT_ANIMATE     = 0x00000010UL,
   GAME_OBJECT_MOVE        = 0x00000020UL,
   GAME_PAUSE              = 0x00000040UL,
   GAME_PLAY_MODE          = 0x00000080UL,
   GAME_OUT_OF_TIME        = 0x00000100UL,
   GAME_NEXT_CAVE          = 0x00000200UL,
   GAME_QUIT_CAVE          = 0x00000400UL,
   GAME_RESET              = 0x00000800UL,
   GAME_PLAYER_DEAD        = 0x00001000UL,
   GAME_BONUS_LIFE         = 0x00002000UL,
   GAME_DEMO_MODE          = 0x00004000UL,
   GAME_MAGIC_WALL         = 0x00008000UL,
   GAME_DIAMONDS_COLLECTED = 0x00010000UL,
   GAME_STATUS_MASK        = 0xfffffff0UL
};

enum GRAPHICS_type
{
   GRAPHICS_UNKNOWN,
   GRAPHICS_SVGALIB,
   GRAPHICS_X11
};


struct PLAYER_DATA
{
   short room;
   short level;
   short lives;
   long  score;
   long  last_bonus;
};

struct GAME_DATA
{
   short graphics_type;
   short start_room;
   short start_level;
   short diamonds;
   short current_player;
   short players_number;
   ulong game_status;
   short scroll_step;
   short scroll_basic_step;
   short border_dist_x;
   short border_dist_y;
   short max_amoeba_size;
};


extern struct GAME_DATA    game_data;
extern struct PLAYER_DATA  player_data[MAX_PLAYERS];
struct FONT_DATA          *bd_font_8x8, *bd_font_16x16;
extern char               *gamelibdir;
extern short               _options;

#ifdef USE_X11
extern struct WINDOW_DATA main_window;
#endif


#if defined (__STDC__) || defined (__cplusplus) || defined (NeedFunctionPrototypes)
#define __PARMS(s) s
#else
#define __PARMS(s) ()
#endif

#ifdef DEBUG
void   show_refresh_rate __PARMS((short init_flag));
#else
#  define show_refresh_rate(a)
#endif

time_t usec_to_sec __PARMS((long usec));
void   game_timer  __PARMS((short init_flag));
void   game_over   __PARMS((char *title));
void   time_bonus  __PARMS((void));
short  game        __PARMS((void));

#undef __PARMS
#endif /* _MAIN_H_ */
